clear all
mata:mata set matastrict on
mata:
void mynormal_lf_m(transmorphic scalar ML, real rowvector b,
                   real colvector lnfj) {

        real scalar     lnsigma
        real vector     depvar, xb

        depvar  = moptimize_util_depvar(ML, 1)
        xb      = moptimize_util_xb(ML, b, 1)
        lnsigma = moptimize_util_xb(ML, b, 2)

        lnfj = lnnormalden(depvar, xb, exp(lnsigma))
}

end

mata: mata mosave mynormal_lf_m(), replace

